module ConfigX
  class NamespaceDelegator
    def initialize(target, namespace = [])
      @target = target
      @namespace = namespace
    end

    attr_accessor :target

    def method_missing(*args, &block)
      method_name = args.shift
      target.send(config_prefixed_name(method_name), *args, &block)
    end

    private

    def config_prefixed_name(name)
      parts = ([CONFIG_NAMESPACE] + @namespace + [name]).compact
      parts.join(Interface::NAMESPACE_SEPARATOR)
    end
  end
end
